#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <pwd.h>
#include <grp.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#ifdef __FreeBSD__
#include <netinet/in.h>
#endif
#include <sys/un.h>
#include <sys/time.h>
#include <time.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/param.h>
#ifdef HAVE_SYS_SCHED_H
#include <sys/sched.h>
#endif
#ifdef HAVE_SCHED_H
#include <sched.h>
#endif
#include <dirent.h>
#include <fcntl.h>

#include "compute.h"
#include "csavi2c.h"

#define SOPHIE_VERSION		"1.44"

#define SOPHIE_LISTEN_QUEUE MAX_PROC
#define	SOPHIE_NET_QUEUE	MAX_PROC
#define PRIORITY			20
#define REPORT_VIRUSNAME	1

#define	SCAN_LOCAL			1
#define	SCAN_NETWORK		2

extern CISavi2 *pSAVI;

#ifndef STDIO_H_DECLARES_VSNPRINTF
extern int vsnprintf(char *, size_t, const char *, va_list);
extern int snprintf(char *, size_t, char *,...);
#endif

#if (!defined(GRP_H_DECLARES_INITGROUPS)) && (!defined(UNISTD_H_DECLARES_INITGROUPS))
extern int initgroups(const char *, gid_t);
#endif

void sophie_init(void);
void sophie_print(int debug, char *printMessage, ...);
void sophie_syslog(char *syslogMessage, ...);
void sophie_log_virus(char *infected_file, CIEnumSweepResults *scan_results);
int sophie_scanfile(char *scan_file);
void sophie_end(void);
void sophie_version(void);
void usage(void);
void sophie_show_settings(void);
int show_config_details(CISavi2 *pSAVI, CIEngineConfig *pConfig);
int sophie_scandir(char *dirpath);
int sophie_net_scan(int s);
int sophie_getline(char *b, int bsize, int bsock);
int file_exists(char *check_if_exists);

int SOPHIE_DEBUG;
int SOPHIE_DAEMON;
int sock;
int tcp_sock;

char *program_name;
char **program_args;
char VIR_NAME[512];
char ret_error_string[256];
